package com.tzld.piaoquan.recommend.server.service.rank;

import com.aliyun.odps.utils.StringUtils;
import com.tzld.piaoquan.recommend.server.service.rank.strategy.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class RankRouter {
    @Autowired
    private RankStrategy4RegionMergeModelV536 rankStrategy4RegionMergeModelV536;
    @Autowired
    private RankStrategy4RegionMergeModelV562 rankStrategy4RegionMergeModelV562;
    @Autowired
    private RankStrategy4RegionMergeModelV563 rankStrategy4RegionMergeModelV563;
    @Autowired
    private RankStrategy4RegionMergeModelV564 rankStrategy4RegionMergeModelV564;
    @Autowired
    private RankStrategy4RegionMergeModelV567 rankStrategy4RegionMergeModelV567;
    @Autowired
    private RankStrategy4RegionMergeModelV569 rankStrategy4RegionMergeModelV569;

    public RankResult rank(RankParam param) {
        String abCode = param.getAbCode();
        if (StringUtils.isBlank(abCode)) {
            return rankStrategy4RegionMergeModelV536.rank(param);
        }
        // 536 562 563 564 567 569
        switch (abCode) {

            case "60112": // 562
                return rankStrategy4RegionMergeModelV562.rank(param);
            case "60113": // 563
                return rankStrategy4RegionMergeModelV563.rank(param); // 60113 CF召回 doing
            case "60114": // 564
                return rankStrategy4RegionMergeModelV564.rank(param); // 60114 排序r-cnt实验 doing
            case "60117": // 567
                return rankStrategy4RegionMergeModelV567.rank(param); // 60117 cf叠加r-cnt模型 doing
            case "60119": // 569
                return rankStrategy4RegionMergeModelV569.rank(param); // rov fm模型 60119 实验关闭
            case "60121": // 536
            default: // base 536
                return rankStrategy4RegionMergeModelV536.rank(param); // vor统计量 doing
        }
    }
}

